## hepmc3 3.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)
#----------------------------------------------------------------------------
project(HepMC3)
set(PROJECT_VERSION 3.01.02)


set(CMAKE_VERBOSE_MAKEFILE ON)

#---Setting HepMC3 Build type-----------------------------------------------
if(CMAKE_BUILD_TYPE)
  message(STATUS "HepMC3 Build type: ${CMAKE_BUILD_TYPE}")
else(CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
  message(STATUS "HepMC3 Build type not specified, use: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)

string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)

#-------------Options-------------------------------------------------------

option(HEPMC3_ENABLE_SEARCH "Enables building of search library" ON)
option(HEPMC3_ENABLE_ROOTIO "Enables building with ROOT O/I." ON)
option(HEPMC3_BUILD_EXAMPLES "Enables building of examples." OFF)
option(HEPMC3_ENABLE_TEST "Enables building of tests." OFF)
option(HEPMC3_INSTALL_INTERFACES "Enables installation of HepMC3 interfaces." OFF)


message(STATUS "HepMC3: HEPMC3_ENABLE_SEARCH         ${HEPMC3_ENABLE_SEARCH}") 
message(STATUS "HepMC3: HEPMC3_ENABLE_ROOTIO         ${HEPMC3_ENABLE_ROOTIO}") 
message(STATUS "HepMC3: HEPMC3_BUILD_EXAMPLES        ${HEPMC3_BUILD_EXAMPLES}") 
message(STATUS "HepMC3: HEPMC3_ENABLE_TEST           ${HEPMC3_ENABLE_TEST}") 
message(STATUS "HepMC3: HEPMC3_INSTALL_INTERFACES    ${HEPMC3_INSTALL_INTERFACES}")

if(HEPMC3_ENABLE_ROOTIO)
  if( EXISTS "$ENV{ROOTSYS}" )
    message(STATUS "HepMC3: ROOTSYS provided $ENV{ROOTSYS}")
  elseif(ROOT_DIR)
    message(STATUS "HepMC3: ROOT_DIR provided ${ROOT_DIR}")
  else() 
    message(STATUS "HepMC3 warning: Building of ROOTIO requested but no ROOTSYS or ROOT_DIR provided")
    message(STATUS "HepMC3 warning: Build will use ROOTConfig.cmake or FindROOT.cmake")
  endif()
endif()

# - Prepend our own CMake Modules to the search path
# This allows us to customize, add, and factor out functionality
# NB: if our custom modules include others that we don't supply, those in the
# base path will be used, so watch for incompatibilities!!
#
set(CMAKE_MODULE_PATH
    ${PROJECT_SOURCE_DIR}/cmake/Modules
    ${CMAKE_MODULE_PATH})

include(CheckCXXCompilerFlag)

CHECK_CXX_COMPILER_FLAG("/D _CRT_SECURE_NO_WARNINGS" COMPILER_SUPPORTS__CRT_SECURE_NO_WARNINGS)
if(COMPILER_SUPPORTS__CRT_SECURE_NO_WARNINGS)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D _CRT_SECURE_NO_WARNINGS /wd4267 /wd4244 /wd4477")
endif()
CHECK_CXX_COMPILER_FLAG("/Zc:__cplusplus" COMPILER_SUPPORTS_ZCPLUSPLUS)
if(COMPILER_SUPPORTS_ZCPLUSPLUS)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
endif()

CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
if(COMPILER_SUPPORTS_CXX11 AND NOT COMPILER_SUPPORTS_ZCPLUSPLUS)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()


if ( "${CMAKE_CXX_COMPILE_FEATURES}"  MATCHES "cxx_range_for" )
message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has cxx_range_for support.")
endif()



message(STATUS "HepMC3: CXX FLAGS ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}  " )


#This module respects HFS, e.g. defines lib or lib64 when it is needed. 
include("GNUInstallDirs")
#### RPATH handling #####

set(CMAKE_MACOSX_RPATH 1)

# use, i.e. don't skip the full RPATH for the build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
   SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
ENDIF("${isSystemDir}" STREQUAL "-1")


#---Optional build of rootIO-------------------------------------------------

if(HEPMC3_ENABLE_ROOTIO)
  set (ROOT_FIND_COMPONENTS Core RIO Tree)
  list(APPEND CMAKE_PREFIX_PATH $ENV{ROOTSYS})
  list(APPEND CMAKE_PREFIX_PATH ${ROOT_DIR})
  find_package(ROOT REQUIRED COMPONENTS Core RIO Tree)
  message(STATUS "ROOT_USE_FILE ${ROOT_USE_FILE}")
  include(${ROOT_USE_FILE})

  message(STATUS "ROOT includes: ${ROOT_INCLUDE_DIRS}")
  message(STATUS "ROOT libraries: ${ROOT_LIBRARIES}")
  message(STATUS "ROOT_FOUND: ${ROOT_FOUND}")

  if(ROOT_FOUND)
    include_directories(${ROOT_INCLUDE_DIRS})
    add_definitions(-DHEPMC3_ROOTIO)
    set(HEPMC3_ROOTIO_LIBRARY "-lHepMC3rootIO" )
  else()
    message(STATUS "HepMC3 warning: ROOT needed for ROOTIO but not found")
    message(STATUS "HepMC3 warning: Skipping HepMC ROOT IO libraries")
    set(HEPMC3_ENABLE_ROOTIO OFF)
  endif()
endif()



########################################################################
## Core
########################################################################
set( hepmc3core_sources 
${PROJECT_SOURCE_DIR}/src/GenCrossSection.cc 
${PROJECT_SOURCE_DIR}/src/GenParticle.cc  
${PROJECT_SOURCE_DIR}/src/GenVertex.cc      
${PROJECT_SOURCE_DIR}/src/Print.cc             
${PROJECT_SOURCE_DIR}/src/Setup.cc             
${PROJECT_SOURCE_DIR}/src/WriterHEPEVT.cc
${PROJECT_SOURCE_DIR}/src/GenEvent.cc         
${PROJECT_SOURCE_DIR}/src/GenPdfInfo.cc   
${PROJECT_SOURCE_DIR}/src/HEPEVT_Wrapper.cc  
${PROJECT_SOURCE_DIR}/src/ReaderAscii.cc        
${PROJECT_SOURCE_DIR}/src/ReaderHEPEVT.cc   
${PROJECT_SOURCE_DIR}/src/WriterAscii.cc
${PROJECT_SOURCE_DIR}/src/GenHeavyIon.cc      
${PROJECT_SOURCE_DIR}/src/GenRunInfo.cc   
${PROJECT_SOURCE_DIR}/src/LHEFAttributes.cc  
${PROJECT_SOURCE_DIR}/src/ReaderAsciiHepMC2.cc  
${PROJECT_SOURCE_DIR}/src/ReaderLHEF.cc     
${PROJECT_SOURCE_DIR}/src/WriterAsciiHepMC2.cc
)

#We need to export all symbols on WIn to build .lib files
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

add_library(objlibcore OBJECT ${hepmc3core_sources})
# shared libraries need PIC
set_property(TARGET objlibcore PROPERTY POSITION_INDEPENDENT_CODE 1)
target_include_directories(objlibcore PUBLIC ${PROJECT_SOURCE_DIR}/include)

add_library(HepMC3 SHARED $<TARGET_OBJECTS:objlibcore>)
add_library(HepMC3_static STATIC  $<TARGET_OBJECTS:objlibcore>)

set_target_properties(HepMC3 PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_LIBDIR})
set_target_properties(HepMC3 PROPERTIES SOVERSION 2)
if (WIN32)
set_target_properties(HepMC3_static PROPERTIES OUTPUT_NAME HepMC3-static ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_LIBDIR})
elseif()
set_target_properties(HepMC3_static PROPERTIES OUTPUT_NAME HepMC3 ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_LIBDIR})
endif()
configure_file(HepMC3-config.in  ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/HepMC3-config )

#---Install build products---------------------------------------------------
install(TARGETS HepMC3 DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libs)
install(TARGETS HepMC3_static DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libs)

install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT devel)

install(FILES  ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/HepMC3-config  DESTINATION  ${CMAKE_INSTALL_BINDIR} COMPONENT libs   PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ  GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

# Generate config CMake files to be used by other projects
#

include(CMakePackageConfigHelpers)

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
set(INTERFACES_INSTALL_DIR ${CMAKE_INSTALL_DATADIR}/HepMC3/interfaces)
set(CONFIG_INSTALL_DIR ${CMAKE_INSTALL_DATADIR}/HepMC3/cmake)

configure_package_config_file(cmake/Templates/HepMC3Config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/outputs/share/HepMC3/cmake/HepMC3Config.cmake
                                 INSTALL_DESTINATION ${CONFIG_INSTALL_DIR}
                                 PATH_VARS INCLUDE_INSTALL_DIR LIB_INSTALL_DIR
                                           INTERFACES_INSTALL_DIR)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/outputs/share/HepMC3/cmake/HepMC3Config-version.cmake
  COMPATIBILITY SameMajorVersion
  )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/outputs/share/HepMC3/cmake/HepMC3Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/outputs/share/HepMC3/cmake/HepMC3Config-version.cmake
        DESTINATION ${CONFIG_INSTALL_DIR} COMPONENT devel)

########################################################################
## Optional packages
########################################################################
#Search engine
if(HEPMC3_ENABLE_SEARCH)
  add_subdirectory(search)
endif()

#Interfaces for some MCEGs
if (HEPMC3_INSTALL_INTERFACES)
  install(DIRECTORY interfaces/ DESTINATION ${INTERFACES_INSTALL_DIR} COMPONENT devel)
endif()

# ROOT support
if(ROOT_FOUND)
   add_subdirectory(rootIO)
endif()

option(USE_INTERFACE_FROM_PYTHIA8 "Use Pythia8ToHepMC3.h from Pythia8" OFF)
# Add the examples subdirectories
if(HEPMC3_BUILD_EXAMPLES)
  set(HepMC_DIR ${CMAKE_BINARY_DIR} CACHE PATH "Current build directory")
  add_subdirectory(examples)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/ DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT examples  PATTERN  "*config"  EXCLUDE)
endif()

#test suite
if(HEPMC3_ENABLE_TEST)
  ENABLE_TESTING()
  add_subdirectory(test)
endif()


# uninstall target
if(NOT TARGET uninstall)
    configure_file(
        "cmake/Templates/cmake_uninstall.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)

    add_custom_target(uninstall
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()
#THis is for developers only
find_program (ASTYLEFORMAT NAMES astyle)
if (ASTYLEFORMAT)
message(STATUS "astyle found!")
ADD_CUSTOM_TARGET(beautyastyle
  COMMAND astyle  --keep-one-line-blocks  src/*cc  rootIO/src/*cc search/src/*cc  examples/*/src/*cc test/*cc  test/*h
  WORKING_DIRECTORY ${DOXYGEN_OUTPUT_DIR}
  )
endif()
########################################################################
## CPACK
########################################################################
#General CPACK settings
INCLUDE(InstallRequiredSystemLibraries)

set(CPACK_PACKAGE_NAME "HepMC3")
set(CPACK_PACKAGE_VENDOR "HepMC3 Developers")
#Should the version be defined above?
set(CPACK_PACKAGE_VERSION 3)
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 1)
set(CPACK_PACKAGE_VERSION_PATCH 2)
set(CPACK_PACKAGE_RELEASE 0)
set(CPACK_PACKAGE_FILE_NAME "HepMC3")
set(CPACK_PACKAGE_DESCRIPTION "Event record library for high energy physics Monte Carlo")

set(CPACK_PACKAGING_INSTALL_PREFIX "/usr")
SET(CPACK_INSTALL_PREFIX "/usr")
SET(CPACK_OUTPUT_FILE_PREFIX binpackages)


SET(CPACK_BINARY_RPM "ON")
#RPM-specific settings
set(CPACK_RPM_PACKAGE_DEBUG ON)
set(CPACK_RPM_PACKAGE_NAME "HepMC3")
set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_RPM_PACKAGE_LICENSE "GPL")
set(CPACK_RPM_PACKAGE_GROUP "General")
set(CPACK_RPM_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}-${CPACK_PACKAGE_RELEASE}")
set(CPACK_RPM_libs_PACKAGE_SUMMARY  "HepMC3 libraries")
set(CPACK_RPM_devel_PACKAGE_SUMMARY "Headers for HepMC3 libraries")
set(CPACK_RPM_search_libs_PACKAGE_SUMMARY  "HepMC3 headers for event navigation")
set(CPACK_RPM_search_devel_PACKAGE_SUMMARY  "HepMC3 libraries for event navigation")
set(CPACK_RPM_examples_PACKAGE_SUMMARY "Examples for HepMC3 library")
set(CPACK_RPM_libs_PACKAGE_DESCRIPTION  ${CPACK_PACKAGE_DESCRIPTION})
set(CPACK_RPM_devel_PACKAGE_DESCRIPTION ${CPACK_PACKAGE_DESCRIPTION})
set(CPACK_RPM_search_libs_PACKAGE_DESCRIPTION  ${CPACK_PACKAGE_DESCRIPTION})

=== examples/CMakeLists.txt ===
# building examples
#------------------
cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)
include_directories(${PROJECT_SOURCE_DIR}/include )


#This is needed for standalone compilation
if (USE_INSTALLED_HEPMC3)
find_package(HepMC3 REQUIRED)
include_directories(${HEPMC3_INCLUDE_DIR})
include(GNUInstallDirs)
if (HEPMC3_ROOTIO_LIB)
  set (ROOT_FIND_COMPONENTS Core RIO Tree)
  list(APPEND CMAKE_PREFIX_PATH $ENV{ROOTSYS})
  list(APPEND CMAKE_PREFIX_PATH ${ROOT_DIR})
  find_package(ROOT REQUIRED COMPONENTS Core RIO Tree)
  message(STATUS "ROOT_USE_FILE ${ROOT_USE_FILE}")
  include(${ROOT_USE_FILE})

  message(STATUS "ROOT includes: ${ROOT_INCLUDE_DIRS}")
  message(STATUS "ROOT libraries: ${ROOT_LIBRARIES}")
  message(STATUS "ROOT_FOUND: ${ROOT_FOUND}")

  if(ROOT_FOUND)
    include_directories(${ROOT_INCLUDE_DIRS})
    add_definitions(-DHEPMC3_ROOTIO)
    set(HEPMC3_ROOTIO_LIBRARY ${HEPMC3_ROOTIO_LIB} )
  endif()
endif()

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("/Zc:__cplusplus" COMPILER_SUPPORTS_ZCPLUSPLUS)
if(COMPILER_SUPPORTS_ZCPLUSPLUS)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
endif()
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
if(COMPILER_SUPPORTS_CXX11)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
else()
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX0X)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
endif()
endif()
endif()
#<-This is needed for standalone compilation 





include(CheckLanguage)
check_language(Fortran)
if (CMAKE_Fortran_COMPILER)
enable_language(Fortran)
get_filename_component (Fortran_COMPILER_NAME ${CMAKE_Fortran_COMPILER} NAME)
message(STATUS "Fortran compiler : ${Fortran_COMPILER_NAME}")
if (CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
set( CMAKE_Fortran_FLAGS  "${CMAKE_Fortran_FLAGS} -fno-automatic -fno-backslash -ffixed-line-length-132")
elseif (CMAKE_Fortran_COMPILER_ID STREQUAL "Intel")
set( CMAKE_Fortran_FLAGS  "${CMAKE_Fortran_FLAGS} -fno-automatic -fno-backslash -extend-source 132")
elseif()
message(STATUS "HepMC3: Don't know how to set Fortran FLAGS for  ${Fortran_COMPILER_NAME} with ID ${Fortran_COMPILER_ID}")
endif ()
if(CMAKE_SYSTEM_NAME MATCHES Darwin)
  set(CMAKE_SHARED_LIBRARY_CREATE_Fortran_FLAGS "${CMAKE_SHARED_LIBRARY_CREATE_Fortran_FLAGS} -flat_namespace -single_module -undefined dynamic_lookup")
else()
endif()
message(STATUS "HepMC3: Fortran FLAGS ${CMAKE_Fortran_FLAGS}")
add_subdirectory(Pythia6Example)
else()
message(STATUS "HepMC3: Fortran compiler not found")
endif()



add_subdirectory(BasicExamples)

add_subdirectory(LHEFExample)

if (WIN32)
message(STATUS "ConvertExampledoes not work  Windows. DISABLED.")
else()
add_subdirectory(ConvertExample)
endif()

add_subdirectory(Pythia8Example)

if(ROOT_FOUND)
  add_subdirectory(RootIOExample)
  add_subdirectory(RootIOExample2)
  add_subdirectory(RootIOExample3)
  add_subdirectory(ViewerExample)
else()
  message(STATUS "Examples: ROOT package not found. ")
  message(STATUS "rootIO_example disabled")
endif()

=== rootIO/CMakeLists.txt ===
#--------
#-root IO

include_directories(${PROJECT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} ${ROOT_INCLUDE_DIRS})

#----------------------------------------------------------------------------
# Generate dictionaries
#
ROOT_GENERATE_DICTIONARY(G__HepMC3rootIO include/rootIO_Classes.hh LINKDEF include/LinkDef.hh OPTIONS -inlineInputHeader)

add_library(HepMC3rootIO SHARED ${PROJECT_SOURCE_DIR}/rootIO/src/WriterRoot.cc ${PROJECT_SOURCE_DIR}/rootIO/src/ReaderRoot.cc ${PROJECT_SOURCE_DIR}/rootIO/src/WriterRootTree.cc ${PROJECT_SOURCE_DIR}/rootIO/src/ReaderRootTree.cc ${PROJECT_SOURCE_DIR}/rootIO/src/Streamers.cc G__HepMC3rootIO.cxx)
set_property(TARGET HepMC3rootIO PROPERTY POSITION_INDEPENDENT_CODE 1)

target_link_libraries(HepMC3rootIO ${ROOT_Tree_LIBRARY} ${ROOT_RIO_LIBRARY} ${ROOT_Core_LIBRARY} HepMC3)
set_target_properties(HepMC3rootIO PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_LIBDIR})
set_target_properties(HepMC3rootIO PROPERTIES SOVERSION 2)
# installs 
install(TARGETS HepMC3rootIO DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT rootIO-libs)
install(DIRECTORY ${PROJECT_BINARY_DIR}/rootIO/ DESTINATION  ${CMAKE_INSTALL_LIBDIR}  COMPONENT rootIO-libs  FILES_MATCHING  PATTERN "*.pcm"  PATTERN "*.rootmap"  PATTERN "CMakeFiles" EXCLUDE  PATTERN "src" EXCLUDE  PATTERN "include" EXCLUDE)
install(DIRECTORY include/HepMC3 DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT rootIO-devel)

=== search/CMakeLists.txt ===
#--------
#-search
#--------
include_directories(${PROJECT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} )

set( hepmc3search_sources 
${PROJECT_SOURCE_DIR}/search/src/Relatives.cc 
${PROJECT_SOURCE_DIR}/search/src/Selector.cc)

add_library(objlibsearch OBJECT ${hepmc3search_sources})

set_property(TARGET objlibsearch PROPERTY POSITION_INDEPENDENT_CODE 1)
target_include_directories(objlibsearch PUBLIC ${PROJECT_SOURCE_DIR}/include)

add_library(HepMC3search SHARED $<TARGET_OBJECTS:objlibsearch>)
add_library(HepMC3search_static STATIC  $<TARGET_OBJECTS:objlibsearch>)

target_link_libraries(HepMC3search  HepMC3)
set_target_properties(HepMC3search PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_LIBDIR})
set_target_properties(HepMC3search PROPERTIES SOVERSION 2)
if (WIN32)
set_target_properties(HepMC3search_static PROPERTIES OUTPUT_NAME HepMC3search-static ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_LIBDIR})
elseif()
set_target_properties(HepMC3search_static PROPERTIES OUTPUT_NAME HepMC3search ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_LIBDIR})
endif()


# installs 
install(TARGETS HepMC3search DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT search-libs)
install(TARGETS HepMC3search_static DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT search-libs)

install(DIRECTORY ${PROJECT_BINARY_DIR}/search/ DESTINATION  ${CMAKE_INSTALL_LIBDIR}  COMPONENT search-libs  FILES_MATCHING PATTERN "CMakeFiles"  EXCLUDE  PATTERN "src"  EXCLUDE PATTERN "include"  EXCLUDE)
install(DIRECTORY include/HepMC3 DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT search-devel)

=== test/CMakeLists.txt ===
macro( hepmc_test testname )
  message( STATUS "building ${testname} for ${testname}" )
  find_file( ${testname}_source ${testname}.cc ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
  ADD_EXECUTABLE(${testname} ${${testname}_source}   ${ARGN} )
  target_include_directories(${testname} BEFORE
  PUBLIC  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src   ${CMAKE_CURRENT_SOURCE_DIR}/../include/)
  target_link_libraries(${testname} PUBLIC  PRIVATE HepMC3 )
  set(srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
  set(builddir ${CMAKE_CURRENT_BINARY_DIR} )
  add_test( ${testname} ${CMAKE_CURRENT_BINARY_DIR}/${testname} )
  file(GLOB INPUT${testname}  "${CMAKE_CURRENT_SOURCE_DIR}/input${testname}*" )
  file(COPY ${INPUT${testname}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
  string(REPLACE "test" "" ${testname} name)
  file(GLOB INPUT${name}  "${CMAKE_CURRENT_SOURCE_DIR}/input${name}*" )
  file(COPY ${INPUT${name}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
endmacro( hepmc_test )

macro( hepmc_root_test testname )
  message( STATUS "building ROOT test ${testname} " )
  find_file( ${testname}_source ${testname}.cc ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
  ADD_EXECUTABLE(${testname} ${${testname}_source}  ${ARGN} )
  target_include_directories(${testname} BEFORE
  PUBLIC  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src   ${CMAKE_CURRENT_SOURCE_DIR}/../include/ ${CMAKE_CURRENT_SOURCE_DIR}/../rootIO/include/)
  target_link_libraries(${testname} HepMC3 HepMC3rootIO)
   
  set(srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
  set(builddir ${CMAKE_CURRENT_BINARY_DIR} )
  add_test( ${testname} ${testname} )
  file(GLOB INPUT${testname}  "${CMAKE_CURRENT_SOURCE_DIR}/input${testname}*" )
  file(COPY ${INPUT${testname}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
  string(REPLACE "test" "" ${testname} name)
  file(GLOB INPUT${name}  "${CMAKE_CURRENT_SOURCE_DIR}/input${name}*" )
  file(COPY ${INPUT${name}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
endmacro( hepmc_root_test )










set( CMAKE_INCLUDE_DIRECTORIES_BEFORE ON )

file(GLOB INPUTFILES  "${CMAKE_CURRENT_SOURCE_DIR}/*.input" )
file(COPY ${INPUTFILES} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

set( HepMC_tests
        testBoost
        testMass
        testPrintBug
        testPolarization 
        testUnits
        testMultipleCopies
        testWeights 
        testLoops
        testDelete
        testIO1
        testIO3
        testIO6
        testReaderFactory1
         )

set( HepMC_root_tests 
        testIO2
        testIO4
        testReaderFactory2
        )


set(srcdir ${CMAKE_CURRENT_SOURCE_DIR} )

find_package(Threads)
if(Threads_FOUND)
  list( APPEND HepMC_tests "testThreads1" )   
else()
  message(STATUS "No threads library found, testThreads1 is disabled")
endif()

foreach ( test ${HepMC_tests} )
  hepmc_test( ${test} )
  set_tests_properties(${test} PROPERTIES TIMEOUT 2000)  #Relevant for testLoops
endforeach ( test ${HepMC_tests} )

if(Threads_FOUND)
if(THREADS_HAVE_PTHREAD_ARG)
  target_compile_options(testThreads1 PUBLIC "-pthread")
endif()
if(CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(testThreads1 PUBLIC "${CMAKE_THREAD_LIBS_INIT}")
endif()
endif()

if(HEPMC3_ENABLE_ROOTIO)
foreach ( test ${HepMC_root_tests} )
  hepmc_root_test( ${test} )
endforeach ( test ${HepMC_root_tests} )
target_link_libraries(testIO4 ${ROOT_Hist_LIBRARY})
endif()



set( libMCEG_sources ValidationControl.cc   SimpleEventTool.cc )
set( libMCEG_sources_HEPMC3  )
set( libMCEG_link_libraries_HEPMC2  )
set( libMCEG_link_libraries_HEPMC3  )
set( libMCEG_include_directories   ${CMAKE_CURRENT_SOURCE_DIR}/../search/include/  )
set( libMCEG_compile_definitions  "-DSIMPLEEVENTTOOL")
set( MCEG_tests )


find_package(Pythia8 )
if(NOT PYTHIA8_FOUND)
  message(STATUS "Validation: Pythia8 package not found. Please check if PYTHIA8_ROOT_DIR is set properly.") 
else()
  message( STATUS "building testPythia for testPythia" )
  list( APPEND libMCEG_sources    "PythiaValidationTool.cc" )
  list( APPEND libMCEG_link_libraries_HEPMC2  "${PYTHIA8_LIBRARIES}")
  list( APPEND libMCEG_link_libraries_HEPMC3  "${PYTHIA8_LIBRARIES}")
  SET(interfacelocation ${PROJECT_SOURCE_DIR}/interfaces/pythia8/include/Pythia8)
  if (USE_INTERFACE_FROM_PYTHIA)
  find_file(interfacefrompythia8 ${PYTHIA8_INCLUDE_DIR}/Pythia8Plugins/Pythia8ToHepMC3.h)
  if (interfacefrompythia8) 
  message(STATUS " Found Pythia8Plugins/Pythia8ToHepMC3.h  in Pythia8 installation in ${PYTHIA8_INCLUDE_DIR}")
  else()
  message(FATAL " Pythia8Plugins/Pythia8ToHepMC3.h  is absent in Pythia8 installation in ${PYTHIA8_INCLUDE_DIR}")
  endif()
  SET(interfacelocation ${PYTHIA8_INCLUDE_DIR}/Pythia8Plugings)
  endif()
  list( APPEND libMCEG_include_directories  "${interfacelocation}"   "${PYTHIA8_INCLUDE_DIRS}")
  list( APPEND libMCEG_compile_definitions  "-DPYTHIA8")

  list( APPEND MCEG_tests "testPythia1" )   
  list( APPEND MCEG_tests "testPythia2" )   
endif()


find_package(Photospp )
if(NOT PHOTOSPP_FOUND)
  message(STATUS "Validation: Photospp package not found. Please check if PHOTOSPP_ROOT_DIR is set properly.") 
else()
  message( STATUS "building testPhotos tests" )
  message(STATUS "PHOTOSPP_LIBRARIES ${PHOTOSPP_LIBRARIES}")
  message(STATUS "PHOTOSPP_HEPMC2_LIBRARIES ${PHOTOSPP_HEPMC2_LIBRARIES}")
  message(STATUS "PHOTOSPP_INCLUDE_DIRS ${PHOTOSPP_INCLUDE_DIRS}")
  list( APPEND  libMCEG_sources   "PhotosValidationTool.cc" )
  list( APPEND  libMCEG_sources_HEPMC3 "${PROJECT_SOURCE_DIR}/interfaces/Photospp/src/PhotosHepMC3Event.cc" "${PROJECT_SOURCE_DIR}/interfaces/Photospp/src/PhotosHepMC3Particle.cc"   )
  list( APPEND  libMCEG_link_libraries_HEPMC2  "${PHOTOSPP_LIBRARIES}"  "${PHOTOSPP_HEPMC2_LIBRARIES}")
  list( APPEND  libMCEG_link_libraries_HEPMC3  "${PHOTOSPP_LIBRARIES}" )
  list( APPEND  libMCEG_include_directories  "${PROJECT_SOURCE_DIR}/interfaces/Photospp/include"  "${PHOTOSPP_INCLUDE_DIRS}")
  list( APPEND  libMCEG_compile_definitions  "-DPHOTOSPP")

  list( APPEND  MCEG_tests "testPhotos1" )   
endif()


find_package(Tauolapp )
if(NOT TAUOLAPP_FOUND)
  message(STATUS "Validation: Tauolapp package not found. Please check if TAUOLA_ROOT_DIR is set properly.") 
else()
  message( STATUS "building testTauola tests" )
  message(STATUS "TAUOLAPP_LIBRARIES ${TAUOLAPP_LIBRARIES}")
  message(STATUS "TAUOLAPP_INCLUDE_DIRS ${TAUOLAPP_INCLUDE_DIRS}")
 list( APPEND  libMCEG_sources "TauolaValidationTool.cc" )
 list( APPEND  libMCEG_sources_HEPMC3 "${PROJECT_SOURCE_DIR}/interfaces/Tauolapp/src/TauolaHepMC3Event.cxx" "${PROJECT_SOURCE_DIR}/interfaces/Tauolapp/src/TauolaHepMC3Particle.cxx"  )
 list( APPEND  libMCEG_link_libraries_HEPMC2  "${TAUOLAPP_LIBRARIES}" )
 list( APPEND  libMCEG_link_libraries_HEPMC3  "${TAUOLAPP_LIBRARIES}" )
 list( APPEND  libMCEG_include_directories  "${PROJECT_SOURCE_DIR}/interfaces/Tauolapp/include"  "${TAUOLAPP_INCLUDE_DIRS}") 
 list( APPEND  libMCEG_compile_definitions  "-DTAUOLAPP")
 list( APPEND  MCEG_tests "testTauola1" )   
endif()



if(HEPMC3_ENABLE_ROOTIO)
find_package(MCTester )
if(NOT MCTESTER_FOUND)
  message(STATUS "Validation: MCTester package not found. Please check if MCTESTER_ROOT_DIR is set properly.") 
else()
  message( STATUS "building testMCTester tests" )
  message(STATUS "MCTESTER_LIBRARIES ${MCTESTER_LIBRARIES}")
  message(STATUS "MCTESTER_INCLUDE_DIRS ${MCTESTER_INCLUDE_DIRS}")
  list( APPEND  libMCEG_sources "McTesterValidationTool.cc" )
  list( APPEND  libMCEG_sources_HEPMC3 "${PROJECT_SOURCE_DIR}/interfaces/mc-tester/src/HepMC3Event.cxx" "${PROJECT_SOURCE_DIR}/interfaces/mc-tester/src/HepMC3Particle.cxx"   )
  list( APPEND  libMCEG_link_libraries_HEPMC2  "${MCTESTER_LIBRARIES}" "${ROOT_LIBRARIES}" )
  list( APPEND  libMCEG_link_libraries_HEPMC3  "${MCTESTER_LIBRARIES}" "${ROOT_LIBRARIES}" )
  list( APPEND  libMCEG_include_directories  "${PROJECT_SOURCE_DIR}/interfaces/mc-tester/include" "${MCTESTER_INCLUDE_DIRS}"  "${ROOT_INCLUDE_DIRS}")
  list( APPEND  libMCEG_compile_definitions  "-DMCTESTER")

  list( APPEND  MCEG_tests "testMCTester1" )   
endif()
endif()


add_library(MCEG3 SHARED ${libMCEG_sources} ${libMCEG_sources_HEPMC3})
target_link_libraries(MCEG3  PRIVATE HepMC3 HepMC3search PUBLIC ${libMCEG_link_libraries_HEPMC3} )
target_compile_definitions(MCEG3  PRIVATE ${libMCEG_compile_definitions})
target_include_directories(MCEG3   BEFORE
PUBLIC  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>  
PRIVATE ${libMCEG_include_directories}
PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src   ${CMAKE_CURRENT_SOURCE_DIR}/../include/)



macro( hepmc_mceghepmc3_test testname )
  message( STATUS "building MCEG3 test ${testname} with HEPMC3" )
  find_file( ${testname}_source ${testname}.cc ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
  ADD_EXECUTABLE(${testname} ${${testname}_source}  ${ARGN} )
  target_include_directories(${testname} BEFORE
  PUBLIC  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src   ${CMAKE_CURRENT_SOURCE_DIR}/../include/  ${CMAKE_CURRENT_SOURCE_DIR}/../search/include/ )
  #The flag is needed for Taoula that conflates generic C++ interface with the HepMC2 interface
  #FIXME put here Visual studio flags when needed
  #For Darwin target_link_libraries(${testname}  "-undefined dynamic_lookup"  HepMC3  MCEG3)   
if (APPLE)  
  target_link_libraries(${testname}  "-undefined dynamic_lookup"  HepMC3  MCEG3)   
else()
  target_link_libraries(${testname}  "-Wl,--allow-shlib-undefined"  HepMC3  MCEG3)   
endif()
  set(srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
  set(builddir ${CMAKE_CURRENT_BINARY_DIR} )
  add_test( ${testname} ${testname} )
  file(GLOB INPUT${testname}  "${CMAKE_CURRENT_SOURCE_DIR}/input${testname}*" )
  file(COPY ${INPUT${testname}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
  string(REPLACE "test" "" ${testname} name)
  file(GLOB INPUT${name}  "${CMAKE_CURRENT_SOURCE_DIR}/input${name}*" )
  file(COPY ${INPUT${name}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
endmacro( hepmc_mceghepmc3_test )


foreach ( test ${MCEG_tests} )
  hepmc_mceghepmc3_test( ${test} )
endforeach ( test ${MCEG_tests} )





find_package(HepMC2 QUIET)

if(NOT HEPMC2_FOUND)
  message(STATUS "HEPMC2 package not found. Please check if HEPMC2_ROOT_DIR is set properly.") 

else()

add_library(MCEG2 SHARED ${libMCEG_sources})
target_link_libraries(MCEG2  PRIVATE ${HEPMC2_LIBRARIES} PUBLIC ${libMCEG_link_libraries_HEPMC2} )
target_compile_definitions(MCEG2  PRIVATE ${libMCEG_compile_definitions} -DHEPMC2)
target_include_directories(MCEG2   BEFORE
PUBLIC ${HEPMC2_INCLUDE_DIRS}
PUBLIC  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>  
PRIVATE ${libMCEG_include_directories}
PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src   )


macro( hepmc_mceghepmc2_test testname )
  message( STATUS "building MCEG2 test ${testname} with HEPMC2" )
  find_file( ${testname}_source ${testname}.cc ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
  ADD_EXECUTABLE(hepmc2_${testname} ${${testname}_source}  ${ARGN} )
  target_compile_definitions(hepmc2_${testname}  PRIVATE  -DHEPMC2)
  target_include_directories(${testname} BEFORE
  PUBLIC  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src   ${CMAKE_CURRENT_SOURCE_DIR}/../include/  ${CMAKE_CURRENT_SOURCE_DIR}/../search/include/ )  
  target_link_libraries(hepmc2_${testname} ${HEPMC2_LIBRARIES}   MCEG2   )
  set(srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
  set(builddir ${CMAKE_CURRENT_BINARY_DIR} )
  add_test( hepmc2_${testname} hepmc2_${testname} )
  file(GLOB INPUThepmc2_${testname}  "${CMAKE_CURRENT_SOURCE_DIR}/input${testname}*" )
  file(COPY ${INPUThepmc2_${testname}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
  string(REPLACE "test" "" ${testname} name)
  file(GLOB INPUThepmc2_${name}  "${CMAKE_CURRENT_SOURCE_DIR}/input${name}*" )
  file(COPY ${INPUThepmc2_${name}} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
endmacro( hepmc_mceghepmc2_test )

=== doc/doxygen/Makefile ===

all: Doxyfile
	doxygen Doxyfile
	@echo "******************************************************"
	@echo " Please load the doxygen documentation file           "
	@echo " documentation/html/index.html in your web browser    "	
	@echo "******************************************************"

clean:
	rm -rf html/
	rm -f *~

=== examples/BasicExamples/CMakeLists.txt ===
# building tests
#------------------
cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)
#

#---Add executables------------------------------------------------------------
if(HEPMC3_ENABLE_SEARCH)
if (WIN32)
message(STATUS "basic_tree.exe does not work  Windows. DISABLED.")
else()
add_executable(basic_tree.exe ${CMAKE_CURRENT_SOURCE_DIR}/basic_tree.cc)
target_link_libraries(basic_tree.exe HepMC3 HepMC3search ${ROOT_LIBRARIES})
target_include_directories(basic_tree.exe PUBLIC  ${CMAKE_SOURCE_DIR}/search/include)
set_target_properties(basic_tree.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})
install(TARGETS basic_tree.exe DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()
endif()

if(CMAKE_Fortran_COMPILER)
 add_executable(hepevt_wrapper_example.exe ${CMAKE_CURRENT_SOURCE_DIR}/hepevt_wrapper_example_main.cc ${CMAKE_CURRENT_SOURCE_DIR}/hepevt_wrapper_example_fortran.f)
 target_link_libraries(hepevt_wrapper_example.exe HepMC3)
 set_target_properties(hepevt_wrapper_example.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

install(TARGETS hepevt_wrapper_example.exe DESTINATION ${CMAKE_INSTALL_BINDIR})

else()
 message(STATUS "No Fortran compiler - dissabling HepEvt example.")
endif()

add_executable(HepMC2_reader_example.exe ${CMAKE_CURRENT_SOURCE_DIR}/HepMC2_reader_example.cc)
target_link_libraries(HepMC2_reader_example.exe HepMC3 ${ROOT_LIBRARIES})
set_target_properties(HepMC2_reader_example.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

install(TARGETS HepMC2_reader_example.exe DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(HepMC3_fileIO_example.exe ${CMAKE_CURRENT_SOURCE_DIR}/HepMC3_fileIO_example.cc)
target_link_libraries(HepMC3_fileIO_example.exe HepMC3 ${ROOT_LIBRARIES})
set_target_properties(HepMC3_fileIO_example.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

install(TARGETS HepMC3_fileIO_example.exe DESTINATION ${CMAKE_INSTALL_BINDIR})

=== examples/ConvertExample/CMakeLists.txt ===

set(basic_sources   ${CMAKE_CURRENT_SOURCE_DIR}/convert_example.cc
                    ${CMAKE_CURRENT_SOURCE_DIR}/cmdline.c
                    ${CMAKE_CURRENT_SOURCE_DIR}/src/WriterDOT.cc 
                    ${CMAKE_CURRENT_SOURCE_DIR}/src/WriterHEPEVTZEUS.cc )
set(basic_includes ${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} )
set(basic_libraries HepMC3)
set(basic_defines   HEPMCCONVERT_EXTENSION_HEPEVTZEUS=1   HEPMCCONVERT_EXTENSION_DOT=1)
set(basic_dependencies )
set(basic_libdir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" )
find_package(ZLIB)
if(ZLIB_FOUND)
list(APPEND basic_includes ${ZLIB_INCLUDE_DIR})
list(APPEND basic_sources  ${CMAKE_CURRENT_SOURCE_DIR}/src/gzstream.C )
list(APPEND basic_libraries ${ZLIB_LIBRARIES})
list(APPEND basic_defines HEPMCCONVERT_EXTENSION_GZ=1)
# create environment scripts
set(basic_libdir "${basic_libdir}:${ZLIB_ROOT}")
endif()

if(ROOT_FOUND)
list(APPEND basic_includes ${PROJECT_SOURCE_DIR}/rootIO/include  ${ROOT_INCLUDE_DIRS})
list(APPEND basic_sources ${CMAKE_CURRENT_SOURCE_DIR}/src/WriterRootTreeOPAL.cc )
list(APPEND basic_libraries ${ROOT_LIBRARIES} HepMC3rootIO)
list(APPEND basic_defines HEPMCCONVERT_EXTENSION_ROOTTREEOPAL=1)
list(APPEND basic_dependencies dictionary)
# create environment scripts
set(basic_libdir "${basic_libdir}:${ROOT_LIBRARY_DIR}")
endif()


add_executable(convert_example.exe  ${basic_sources} )
include_directories(${basic_includes})
target_link_libraries(convert_example.exe ${basic_libraries} )
target_compile_definitions(convert_example.exe PRIVATE ${basic_defines} )
if (basic_dependencies)
add_dependencies( convert_example.exe ${basic_dependencies} )
endif()
# create environment scripts
set(bindir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set(libdir ${basic_libdir})
set_target_properties(convert_example.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})
 
configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/convert_example_env.sh.in
	    ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/convert_example_env.sh @ONLY)

# installs 
install(TARGETS convert_example.exe DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${CMAKE_INSTALL_BINDIR} FILES_MATCHING PATTERN "*.pcm" PATTERN "*config"  PATTERN "CMakeFiles" EXCLUDE )
install(DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/ DESTINATION ${CMAKE_INSTALL_BINDIR}  FILES_MATCHING PATTERN "*env.sh*")






#The cmdline.c and cmdline.h for this example are generated from file below
#gengetopt -N  --no-version --input=hepmcconvert.ggo --include-getopt --show-required -u"inputfile outputfile"
#version "3.1"
#package "hepmcconvert"
#purpose "Convert between different file formats of Monte Carlo event record.
#Example:
#         hepmcconvert -i hepmc2 -o treeroot input.hepmc output.root
#"
#option "input-format" i "Input format" string required values="hepmc2", "hepmc3", "hpe" ,"root", "treeroot","lhef","gz"
#option "output-format" o "Output format" string required values="hepmc2", "hepmc3", "hpe" ,"root", "treeroot" ,"treerootopal","hpezeus", "dump", "dot"
#option "extensions" e "Extensions, in a form extension=value, could be passed to readers/writers" multiple optional string
#option "events-limit" - "Limit of events to read from input" optional long default="100000000"
#option "first-event-number" -       "Lowest allowed event number" optional long default="-100000000"
#option "last-event-number" -        "Highest allowed event number" optional long default="100000000"
#option "print-every-events-parsed" - "Frequency of parsing information printouts" optional long default="100"

=== examples/LHEFExample/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(LHEF_example_cat.exe ${CMAKE_CURRENT_SOURCE_DIR}/LHEF_example_cat.cc)
target_link_libraries(LHEF_example_cat.exe HepMC3 ${ROOT_LIBRARIES})
set_target_properties(LHEF_example_cat.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

# create environment scripts

set(bindir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set(libdir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
 
configure_file(
${CMAKE_CURRENT_SOURCE_DIR}/LHEF_example_env.sh.in
	    ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/LHEF_example_env.sh
     	     @ONLY
      	     )

# installs 

install(TARGETS LHEF_example_cat.exe DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES LHEF_example.lhe LHEF_example_cmp.lhe DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/ DESTINATION ${CMAKE_INSTALL_BINDIR}
        FILES_MATCHING PATTERN "*env.sh*")

=== examples/Pythia6Example/CMakeLists.txt ===
if (USE_INSTALLED_HEPMC3)
include_directories(${HEPMC3_INCLUDE_DIR} ${HEPMC3_INCLUDE_DIR}/rootIO)
set (ptoh3 ${HEPMC3_INTERFACES_DIR}/pythia6/include/Pythia6/Pythia6ToHepMC3.cc)
else()
include_directories(${PROJECT_SOURCE_DIR}/include ${PROJECT_SOURCE_DIR}/rootIO/include/)
set (ptoh3 ${PROJECT_SOURCE_DIR}/interfaces/pythia6/include/Pythia6/Pythia6ToHepMC3.cc)
endif()
add_executable(pythia6_example.exe ${CMAKE_CURRENT_SOURCE_DIR}/main63.f ${CMAKE_CURRENT_SOURCE_DIR}/pythia-6.4.28.f ${ptoh3})
LINK_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../outputs/lib64/  ${CMAKE_CURRENT_SOURCE_DIR}/../outputs/lib/ )
if(ROOT_FOUND)
target_link_libraries(pythia6_example.exe  HepMC3 HepMC3rootIO)
include_directories(${ROOT_INCLUDE_DIRS})
else()
target_link_libraries(pythia6_example.exe  HepMC3)
endif()
set_target_properties(pythia6_example.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

install(TARGETS pythia6_example.exe DESTINATION ${CMAKE_INSTALL_BINDIR})

=== examples/Pythia8Example/CMakeLists.txt ===
if (USE_INSTALLED_HEPMC3)
#This version is for standalone compilation of examples.
option(USE_INTERFACE_FROM_PYTHIA8 "Use Pythia8/Pythia8ToHepMC3.h from Pythia8" OFF)
set(CMAKE_MODULE_PATH    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules    ${CMAKE_MODULE_PATH})
find_package(Pythia8 QUIET)
if(PYTHIA8_FOUND)
SET(interfacelocation ${HEPMC3_INTERFACES_DIR}/pythia8/include/Pythia8)
if (USE_INTERFACE_FROM_PYTHIA)
find_file(interfacefrompythia8 ${PYTHIA8_INCLUDE_DIR}/Pythia8Plugins/Pythia8ToHepMC3.h)
if (interfacefrompythia8) 
message(STATUS " Found Pythia8Plugins/Pythia8ToHepMC3.h  in Pythia8 installation in ${PYTHIA8_INCLUDE_DIR}")
else()
message(FATAL_ERROR " Pythia8Plugins/Pythia8ToHepMC3.h  is absent in Pythia8 installation in ${PYTHIA8_INCLUDE_DIR}")
endif()
SET(interfacelocation ${PYTHIA8_INCLUDE_DIR}/Pythia8Plugings)
endif()
include_directories(${PROJECT_SOURCE_DIR}/include ${interfacelocation} ${PYTHIA8_INCLUDE_DIR})
add_executable(pythia8_example.exe ${CMAKE_CURRENT_SOURCE_DIR}/pythia8_example.cc )
endif()
else()
#This version is for compilation during installation. Should be consistent with Pythia used in tests
set(PYTHIA8_ROOT_DIR "" CACHE PATH "Location of Pythia8 installation.")
find_package(Pythia8 QUIET)
if(PYTHIA8_FOUND)
SET(interfacelocation ${PROJECT_SOURCE_DIR}/interfaces/pythia8/include/Pythia8)
if (USE_INTERFACE_FROM_PYTHIA)
find_file(interfacefrompythia8 ${PYTHIA8_INCLUDE_DIR}/Pythia8Plugins/Pythia8ToHepMC3.h)
if (interfacefrompythia8) 
message(STATUS " Found Pythia8Plugins/Pythia8ToHepMC3.h  in Pythia8 installation in ${PYTHIA8_INCLUDE_DIR}")
else()
message(FATAL_ERROR " Pythia8Plugins/Pythia8ToHepMC3.h  is absent in Pythia8 installation in ${PYTHIA8_INCLUDE_DIR}")
endif()
SET(interfacelocation ${PYTHIA8_INCLUDE_DIR}/Pythia8Plugings)
endif()
find_file(interfacefrompythia8 ${PYTHIA8_INCLUDE_DIR}/Pythia8Plugins/Pythia8ToHepMC3.h)
include_directories(${PROJECT_SOURCE_DIR}/include ${interfacelocation} ${PYTHIA8_INCLUDE_DIR})
add_executable(pythia8_example.exe ${CMAKE_CURRENT_SOURCE_DIR}/pythia8_example.cc )
endif()
endif()


if(PYTHIA8_FOUND)
target_link_libraries(pythia8_example.exe ${PYTHIA8_LIBRARIES} HepMC3)
set_target_properties(pythia8_example.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

# create environment scripts

set(bindir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}")
get_filename_component(PYTHIA8_LIB_DIR ${PYTHIA8_LIBRARY} PATH)
set(libdir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}:${PYTHIA8_LIB_DIR}")
set(pythia8data "${PYTHIA8_XMLDOC_DIR}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/pythia8_example_env.sh.in
	       ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/pythia8_example_env.sh
     	       @ONLY
      	       )
# installs 

install(TARGETS pythia8_example.exe DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES pythia8_ee_to_Z_to_tautau.conf DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/ DESTINATION ${CMAKE_INSTALL_BINDIR}
        FILES_MATCHING PATTERN "*env.sh*")

else()
  message(STATUS "Examples: Pythia8 package not found. Please check if PYTHIA8_ROOT_DIR is set properly.")
  message(STATUS "pythia8_example disabled")
endif()

=== examples/RootIOExample/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/rootIO/include ${ROOT_INCLUDE_DIR})

add_executable(rootIO_example_read.exe ${CMAKE_CURRENT_SOURCE_DIR}/rootIO_example_read.cc)
target_link_libraries(rootIO_example_read.exe ${ROOT_LIBRARIES} HepMC3 HepMC3rootIO)
set_target_properties(rootIO_example_read.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

add_executable(rootIO_example_write.exe ${CMAKE_CURRENT_SOURCE_DIR}/rootIO_example_write.cc)
target_link_libraries(rootIO_example_write.exe ${ROOT_LIBRARIES} HepMC3 HepMC3rootIO)
set_target_properties(rootIO_example_write.exe PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR})

# create environment scripts

set(bindir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set(libdir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}:${ROOT_LIBRARY_DIR}")
 
configure_file(
${CMAKE_CURRENT_SOURCE_DIR}/rootIO_example_env.sh.in
	    ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/rootIO_example_env.sh
     	     @ONLY
      	     )

# installs 
install(TARGETS rootIO_example_write.exe rootIO_example_read.exe DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES example.hepmc3 DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${PROJECT_BINARY_DIR}/outputs/${CMAKE_INSTALL_BINDIR}/ DESTINATION ${CMAKE_INSTALL_BINDIR}
        FILES_MATCHING PATTERN "*env.sh*")

=== debian/changelog ===
hepmc3 (3.1.2-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:04:50 +0100

hepmc3 (3.1.2-2) unstable; urgency=medium

  * Move doxygen from B-D-I to B-D. (Closes: #933629)
  * Don't run unit tests on arch=all.
  * Fixup FTBFS on any architecture.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 19 Sep 2019 14:14:37 +0800

hepmc3 (3.1.2-1) unstable; urgency=medium

  [ Andrii Verbytskyi ]
  * New upstream release 3.1.2

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 18 Sep 2019 23:12:13 +0800

=== debian/control ===
Source: hepmc3
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: HepMC developers <hepmc-dev@NOSPAM.cern.ch>,
           Mo Zhou <cdluminate@gmail.com>,
Build-Depends: debhelper (>= 9~), cmake, doxygen
Standards-Version: 4.3.0
Homepage: http://hepmc.web.cern.ch/hepmc/
Vcs-Git: https://salsa.debian.org/science-team/hepmc3.git
Vcs-Browser: https://salsa.debian.org/science-team/hepmc3

Package: libhepmc3
Section: libs
Architecture: any
Multi-arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libhepmc3-search
Suggests: libhepmc3-dev, libhepmc3-search-dev
Description: Event Record for Monte Carlo Generators
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package. 
 .
 This package ships the shared object for HepMC3.

Package: libhepmc3-dev
Section: libdevel
Architecture: any
Depends: libhepmc3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: libhepmc3-search-dev
Suggests: hepmc3-doc
Description: Event Record for Monte Carlo Generators - development files
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package provides development files for HepMC3.

Package: libhepmc3-search
Section: libs
Architecture: any
Depends: libhepmc3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: hepmc3-doc
Description: Monte Carlo event record FIO library -  search engine
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package ships the shared object for HepMC3 search engine.

Package: libhepmc3-search-dev
Section: libdevel
Architecture: any
Depends: libhepmc3-search (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: hepmc3-doc
Description: Event Record for Monte Carlo Generators - development files for search engine
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
 Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package providesthe development files  for HepMC3 search engine.

Package: hepmc3-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: libhepmc3-dev, libhepmc3
Description: Event Record for Monte Carlo Generators (docs)
 The HepMC package is an object oriented event record written in C++ for
 High Energy Physics Monte Carlo Generators.
 .
  Many extensions from HEPEVT, the Fortran HEP standard, are supported: the
 number of entries is unlimited, spin density matrices can be stored with
 each vertex, flow patterns (such as color) can be stored and traced,
 integers representing random number generator states can be stored, and an
 arbitrary number of event weights can be included. Particles and vertices
 are kept separate in a graph structure, physically similar to a physics
 event.
 .
 The added information supports the modularisation of event generators.
 Event information is accessed by means of iterators supplied with the
 package.
 .
 This package provides documentation  and examples for HepMC3.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS  = hardenning=+all
export DEB_LDFLGAS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ -Scmake

#We don't have root6 on Debian
override_dh_auto_configure:
	dh_auto_configure -- \
		-DHEPMC3_ENABLE_ROOTIO=OFF \
		-DHEPMC3_ENABLE_TEST=ON \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_SKIP_INSTALL_RPATH=ON \
		-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	cd doc/doxygen; doxygen Doxyfile

override_dh_auto_test-arch:
	dh_auto_test

override_dh_auto_test-indep:
	true

override_dh_installdocs-arch:
	dh_installdocs

override_dh_installdocs-indep:
	dh_installdocs
	dh_doxygen
